const { Command } = require('commander');
import CommandManager from './command-manager';

let params: any = [];

export default function create(command: any, customerCommandName?: string, description?: string) {

  const _command = new Command(command);
  let processArgv: any = [];
  let start = false;
  let next = false;

  for (let i = 0; i < process.argv.length; i++) {
    if (!start || ['-t', '--template'].includes(process.argv[i]) || next === true) {
      if (next === true) {
        next = false;
      }
      if (['-t', '--template'].includes(process.argv[i])) {
        next = true;
      }
      processArgv.push(process.argv[i]);
    } else {
      params.push(process.argv[i]);
    }
    if (process.argv[i] === command) {
      start = true;
    }
  }
  process.argv = processArgv;

  _command
    .description(description || '')
    .option(
      '-t, --template [template]',
      ''
    )
    .action((program: any) => {
      const { template } = program;
      const commandManager = new CommandManager(command, customerCommandName, template, params.join(' '));
      commandManager.init();
    });
  return _command;
}

